from RandomForests import RandomForestClassifier, RandomForestRegressor
import numpy, random
from sklearn.metrics import mean_squared_error

def generate_random_matrix(n, m, categ_freq):

    def generate_random_categ_column(n):
        a = []
        for _ in range(n):
            a.append("class%s" % random.randint(1, 10))
        return numpy.array(a)

    def generate_random_numer_column(n):
        return numpy.random.randint(1, 100, n)

    matrix = []
    for _ in range(m):
        if random.random() < categ_freq:
            matrix.append(generate_random_categ_column(n))
        else:
            matrix.append(generate_random_numer_column(n))
    matrix = numpy.array(matrix)
    matrix = numpy.transpose(matrix)
    return matrix

# only one class case
X = generate_random_matrix(100, 100, 0.3)
y = [1] * 100
classifier = RandomForestClassifier(8)
classifier.fit(X, y)
test_X = generate_random_matrix(1000, 100, 0.3)
print classifier.predict(test_X)
print classifier.predict_proba(test_X)

regressor = RandomForestRegressor(8)
regressor.fit(X, y)
print regressor.predict(test_X)

# answer directly included in the training set
X = generate_random_matrix(1000, 10, 0.3)
y = [0] * 500 + [1] * 500
X = numpy.transpose(X)
X[9] = y
X = numpy.transpose(X)

def shuffled(X):
    random.shuffle(X)
    return X

def get_score(truth, predictions):
    return sum(map(lambda (x, y): 1 if x == y else 0, zip(truth, predictions)))

X, y = zip(*(shuffled(zip(X, y))))
X = numpy.array(X)
y = numpy.array(y)
X_train, X_test = X[:900], X[900:] 
y_train, y_test = y[:900], y[900:] 

classifier.fit(X_train, y_train)
print get_score(classifier.predict(X_test), y_test)

regressor.fit(X_train, y_train)
print mean_squared_error(regressor.predict(X_test), y_test)

# predict what you have just seen
X_train, X_test = X[:100], X[:100] 
y_train, y_test = y[:100], y[:100] 

classifier.fit(X_train, y_train)
print get_score(classifier.predict(X_test), y_test)

regressor.fit(X_train, y_train)
print mean_squared_error(regressor.predict(X_test), y_test)

